%bcond_without repolib

%global namedversion %{version}

Name:           atinject
Version:        1
Release:        8.2_redhat_1%{?dist}.1
Epoch:          0
Summary:        Dependency injection specification for Java (JSR-330)
Group:          Development/Libraries/Java
License:        ASL 2.0
URL:            http://code.google.com/p/atinject/
# svn export -r 86 http://atinject.googlecode.com/svn/tags/1/ atinject-1 && tar cjf atinject-1.tar.bz2 atinject-1
%if 0
XXX: rather than take from
XXX: http://atinject.googlecode.com/svn/tags/javax.inject-tck-1/, we just patch
XXX: the current build, as this woudl rquire creating a separate RPM .spec
%endif
Source0:        %{name}-%{namedversion}.tar.bz2
Source1:        javax.inject-1-redhat-1.pom
Source2:        javax.inject-tck-1.1-SNAPSHOT-redhat-1.pom
Patch0:         atinject-tck.patch
Provides:       javax.inject = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  apache-commons-parent
BuildRequires:  junit
BuildRequires:  maven2
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-compiler
BuildRequires:  vman
BuildRequires:  jboss-parent
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
This package specifies a means for obtaining objects in such a way as
to maximize reusability, testability and maintainability compared to
traditional approaches such as constructors, factories, and service
locators (e.g., JNDI). This process, known as dependency injection, is
beneficial to most nontrivial applications.

%package tck
Summary:        TCK for javax.inject
Group:          Development/Libraries/Java
Provides:       javax.inject-tck = %{epoch}:%{version}-%{release}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       junit

%description tck
TCK for javax.inject.

%package javadoc
Summary:        API documentation for javax.inject
Group:          Documentation
Requires:       jpackage-utils

%description javadoc
API documentation for javax.inject.

%package tck-javadoc
Summary:        API documentation for javax.inject-tck
Group:          Documentation
Requires:       jpackage-utils

%description tck-javadoc
API documentation for javax.inject-tck.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0

%{__rm} -r lib/ javadoc/
%{__mkdir} lib
%{__ln_s} `%{_bindir}/build-classpath junit` lib/junit.jar

%build
/bin/sh ./build.sh

%install
%{__rm} -rf %{buildroot}

# jar files
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p build/maven/javax.inject-%{namedversion}.jar %{buildroot}%{_javadir}/javax.inject-%{namedversion}.jar
%{__cp} -p build/maven/javax.inject-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/javax.inject-%{namedversion}-javadoc.jar
%{__cp} -p build/maven/javax.inject-%{namedversion}-sources.jar %{buildroot}%{_javadir}/javax.inject-%{namedversion}-sources.jar
%{__cp} -p build/tck/dist/javax.inject-tck.jar %{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}.jar
%{__cp} -p build/tck/dist/javax.inject-tck-javadoc.zip %{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}-javadoc.jar
%{__cp} -p build/tck/dist/javax.inject-tck-src.zip %{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p %{SOURCE1} %{buildroot}%{_datadir}/maven2/poms/JPP-javax.inject.pom
%{__cp} -p %{SOURCE2} %{buildroot}%{_datadir}/maven2/poms/JPP-javax.inject-tck.pom
%add_to_maven_depmap javax.inject javax.inject %{namedversion} JPP javax.inject
%add_to_maven_depmap javax.inject javax.inject-tck %{namedversion} JPP javax.inject-tck

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/javax.inject-%{namedversion}
%{__cp} -pr build/javadoc/* %{buildroot}%{_javadocdir}/javax.inject-%{namedversion}
%{__ln_s} javax.inject-%{namedversion} %{buildroot}%{_javadocdir}/javax.inject
%{__mkdir_p} %{buildroot}%{_javadocdir}/javax.inject-tck-%{namedversion}
%{__unzip} -qqo build/tck/dist/javax.inject-tck-javadoc.zip -d %{buildroot}%{_javadocdir}/javax.inject-tck-%{namedversion}
%{__ln_s} javax.inject-tck-%{namedversion} %{buildroot}%{_javadocdir}/javax.inject-tck

%if %with repolib
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{SOURCE1} -Dfile=build/maven/javax.inject-%{namedversion}.jar -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{SOURCE1} -Dfile=build/maven/javax.inject-%{namedversion}-javadoc.jar -Dclassifier=javadoc -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{SOURCE1} -Dfile=build/maven/javax.inject-%{namedversion}-sources.jar -Dclassifier=sources -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{SOURCE2} -Dfile=build/tck/dist/javax.inject-tck.jar -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{SOURCE2} -Dfile=build/tck/dist/javax.inject-tck-javadoc.zip -Dclassifier=javadoc -Dpackaing=jar -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{SOURCE2} -Dfile=build/tck/dist/javax.inject-tck-src.zip -Dclassifier=sources -Dpackaing=jar -Durl=${URL} -DrepositoryId=oss-releases
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/javax.inject-%{namedversion}.jar
%{_javadir}*/javax.inject.jar
%{_javadir}*/javax.inject-%{namedversion}-javadoc.jar
%{_javadir}*/javax.inject-javadoc.jar
%{_javadir}*/javax.inject-%{namedversion}-sources.jar
%{_javadir}*/javax.inject-sources.jar
%{_datadir}/maven2/poms/JPP-javax.inject.pom
%{_mavendepmapfragdir}/%{name}

%files tck
%defattr(0644,root,root,0755)
%{_javadir}*/javax.inject-tck-%{namedversion}.jar
%{_javadir}*/javax.inject-tck.jar
%{_javadir}*/javax.inject-tck-%{namedversion}-javadoc.jar
%{_javadir}*/javax.inject-tck-javadoc.jar
%{_javadir}*/javax.inject-tck-%{namedversion}-sources.jar
%{_javadir}*/javax.inject-tck-sources.jar
%{_datadir}/maven2/poms/JPP-javax.inject-tck.pom

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/javax.inject-%{namedversion}
%{_javadocdir}/javax.inject

%files tck-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/javax.inject-tck-%{namedversion}
%{_javadocdir}/javax.inject-tck

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1-8.2_redhat_1.1
- Rebuild using cache signing

* Fri Feb 03 2012 Yong Yang <yyang@redhat.com> 0:1-8.2_redhat_1
- Latest vman on-fly, resign

* Tue Sep 20 2011 David Walluck <dwalluck@redhat.com> 0:1-8.1_redhat_1
- Build for werewolf

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 0:1-8
- fix tck depmap entry

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 0:1-7
- use the upstream TCK POM
- TCK groupId on central is wrong

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 0:1-6
- fix Group
- fix POM file name
- install and deploy all tck jars
- add tck and tck-javadoc packages

* Wed Aug 10 2011 David Walluck <dwalluck@redhat.com> 0:1-5
- fix install

* Mon Jun 13 2011 David Walluck <dwalluck@redhat.com> 0:1-4
- fix depmap

* Tue Jun 07 2011 David Walluck <dwalluck@redhat.com> 0:1-3
- add repolib
- export svn from tag
- use build.sh script, not maven

* Thu Dec 29 2010 David Walluck <dwalluck@redhat.com> 0:1-2.20100611svn86
- adapt to JPackage

* Tue Sep 21 2010 Stanislav Ochotnicky <sochotnicky@redhat.com> - 1-1.20100611svn86
- Initial version of the package
